diff --git a/doc/src/sgml/catalogs.sgml b/doc/src/sgml/catalogs.sgml
index b4a06e4..3d7a289 100644
--- a/doc/src/sgml/catalogs.sgml
+++ b/doc/src/sgml/catalogs.sgml
@@ -109,6 +109,11 @@
      </row>
 
      <row>
+      <entry><link linkend="catalog-pg-custom-plan-provider"><structname>pg_custom_plan_provider</structname></link></entry>
+      <entry>custom plan providers</entry>
+     </row>
+
+     <row>
       <entry><link linkend="catalog-pg-conversion"><structname>pg_conversion</structname></link></entry>
       <entry>encoding conversion information</entry>
      </row>
@@ -2508,6 +2513,60 @@
 
  </sect1>
 
+ <sect1 id="catalog-pg-custom-plan-provider">
+  <title><structname>pg_custom_plan_provider</structname></title>
+
+  <indexterm zone="catalog-pg-custom-plan-provider">
+   <primary>pg_custom_plan_provider</primary>
+  </indexterm>
+
+  <para>
+   The catalog <structname>pg_custom_plan_provider</structname> describes
+   custom-plan providers. See <xref linkend="sql-createcustomplanprovider">
+   for more information.
+  </para>
+
+  <table>
+   <title><structname>pg_custom_plan_provider</> Columns</title>
+   <tgroup cols="4">
+    <thead>
+     <row>
+      <entry>Name</entry>
+      <entry>Type</entry>
+      <entry>References</entry>
+      <entry>Description</entry>
+     </row>
+    </thead>
+    <tbody>
+     <row>
+      <entry><structfield>oid</structfield></entry>
+      <entry><type>oid</type></entry>
+      <entry></entry>
+      <entry>Row identifier (hidden attribute; must be explicitly selected)</entry>
+     </row>
+     <row>
+      <entry><structfield>cppname</structfield></entry>
+      <entry><type>name</type></entry>
+      <entry></entry>
+      <entry>custom-plan provider name</entry>
+     </row>
+     <row>
+      <entry><structfield>cppclass</structfield></entry>
+      <entry><type>char</type></entry>
+      <entry></entry>
+      <entry>class of custom-plan node on which this custom-plan provider can perform</entry>
+     </row>
+     <row>
+      <entry><structfield>cpphandler</structfield></entry>
+      <entry><type>regproc</type></entry>
+      <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
+      <entry>handler function of custom-plan provder that will propose an alternative query execution path</entry>
+     </row>
+    </tbody>
+   </tgroup>
+  </table>
+ </sect1>
+
  <sect1 id="catalog-pg-database">
   <title><structname>pg_database</structname></title>
 
diff --git a/doc/src/sgml/custom-plan-provider.sgml b/doc/src/sgml/custom-plan-provider.sgml
new file mode 100644
index 0000000..d86495b
--- /dev/null
+++ b/doc/src/sgml/custom-plan-provider.sgml
@@ -0,0 +1,431 @@
+<!-- doc/src/sgml/custom_plan.sgml -->
+
+<chapter id="custom-plan">
+ <title>Writing A Custom Plan Provider</title>
+ <indexterm zone="custom-plan">
+  <primary>custom plan provider</primary>
+  <secondary>handler for</secondary>
+ </indexterm>
+
+ <para>
+  PostgreSQL has variable kind of built-in plan nodes that implement
+  a particular portion to process the supplied SQL queries.
+  For example, SeqScan node implements full table scan, HashJoin node
+  implements tables join using a hash table and so on.
+ </para>
+ <para>
+  The custom-plan interface allows extensions to provide alternative
+  query execution paths, in addition to the built-in ones. Query planner
+  will choose the cheapest path towards a particular relation(s) scan or
+  join in all the proposed ones by built-in and extensions.
+  Once a proposed custom-plan got picked up, callback functions associated
+  with the node shall be called and extension will get control to process
+  the task. We call the extension that provides custom-plan custom plan
+  provider.
+ </para>
+
+ <sect1 id="cpp-overall-steps">
+  <title>Custom Plan Overall Steps</title>
+  <para>
+   A custom plan provider can be registered using
+   <xref linkend="sql-createcustomplanprovider"> command.
+   It takes a class of custom plan and its handler function.
+   Class of custom plan specifies the task to be replaced by the custom-
+   plan being defined.
+   Only <literal>SCAN</> is the supported class of custom-plan right now.
+   Custom plan handler function is an entrypoint to the planner. It calls
+   the handler function during construction of query execution path.
+  </para>
+  <para>
+   Handler function has to be declared as a function that takes one
+   <literal>internal</> data type and returns <literal>void</>.
+   On invocation, query planner delivers a pointer of data structure
+   according to the custom plan class, custom-plan handler function will
+   decide whether it can offer alternative execution path towards the
+   required task. If available, it can add a <literal>CustomPath</>
+   (or inherited object type) as one of the candidate execution path
+   with estimated cost and set of callbacks defined in the
+   <literal>CustomPathMethods</> structure.
+  </para>
+  <para>
+   Planner compares all the potential execution paths based on its cost.
+   Once a custom path that was added by custom plan provider gets chosen,
+   <literal>CreateCustomPlan</> callback shall be called, to populate
+   a <literal>CustomPlan</> (or inherited object type) node according to
+   the <literal>CustomPath</> node preliminary constructed.
+   In the similar manner, <literal>CreateCustomPlanState</> callback shall
+   be called, to populate a <literal>CustomPlanState</> (or inherited
+   object type) node according to the <literal>CustomPlan</> node being
+   constructed above.
+   The reason why custom-plan provider has to allocate a node object by
+   itself is that we allow to extend the base types to store private
+   fields managed by individual custom-plan providers, thus only custom-
+   plan provider knows actual data size to be allocated.
+  </para>
+  <para>
+   Once a <literal>CustomPlanState</> is constructed, its callback
+   functions are invoked by executor, so custom-plan provider performs
+   required tasks then pops up the result.
+  </para>
+ </sect1>
+
+ <sect1 id="cpp-handler-function">
+  <title>Custom Plan Handler Functions</title>
+  <para>
+   A handler function that was specified on
+   the <xref linkend="sql-createcustomplanprovider"> command is
+   declared to return <literal>void</> data type and takes an
+   <literal>internal</> data type; that is usually applied to exchange
+   internal data structure.
+   This handler function is not an exception. It can reference a pointer
+   being informed via function argument to understand the context.
+  </para>
+  <para>
+   The data structure of arguments fully depend on the class of custom-
+   plan. In case of <literal>SCAN</> class (that is only supported one
+   right now), the first argument points the following data structure
+   that has enough information to construct a <literal>Path</> node.
+<programlisting>
+typedef struct {
+    uint32          cpp_class;
+    PlannerInfo    *root;
+    RelOptInfo     *baserel;
+    RangeTblEntry  *rte;
+} customScanArg;
+</programlisting>
+   <literal>cpp_class</>is always <literal>CUSTOMPLAN_CLASS_SCAN</>
+   that shows this structure is for scan class.
+   <literal>root</> is <literal>PlannerInfo</> of this plan,
+   <literal>baserel</> is <literal>RelOptInfo</> of the relation to
+   be scanned, and <literal>rte</> is <literal>RangeTblEntry</> of
+   the relation.
+  </para>
+  <para>
+   The custom-plan provider being invoked can check whether it can
+   provides alternative way to scan the relation. If available, it
+   shall construct <literal>CustomPath</> or its inherited one with
+   estimated cost and callbacks below, then register the path using
+   <literal>add_path</> towards the supplied <literal>RelOptInfo</>.
+  </para>
+ </sect1>
+
+ <sect1 id="cpp-path-callbacks">
+  <title>Custom Path Callbacks</title>
+  <para>
+   This section introduces callback functions of <literal>CustomPath</>
+   structure; defined in the <literal>CustomPathMethods</>.
+  </para>
+  <para>
+<programlisting>
+Node *
+CreateCustomPlan(PlannerInfo *root,
+                 CustomPath *best_path);
+</programlisting>
+   It populates a <literal>CustomPlan</> (or inherited data type) node
+   according to the supplied <literal>CustomPath</> node which was
+   constructed on the custom plan handler function then chosen by the
+   query planner.
+   Only custom plan provider can know exact size of the node to be
+   allocated, this callback allocate a <literal>CustomPlan</> node with
+   <literal>CustomPlanMethods</> callbacks table and arbitrary private
+   fields.
+  </para>
+  <para>
+   Note that the node tag can be assigned is either <literal>CustomPlan</>
+   or <literal>CustomPlanMarkPos</>. The later one indicates this plan
+   node supports mark and restore position during query execution, but
+   has identical data structure.
+  </para>
+
+
+  <para>
+<programlisting>
+void
+TextOutCustomPath(StringInfo str, const CustomPath *node);
+</programlisting>
+   It makes a text representation of custom path node. If custom-plan
+   provider extends <literal>CustomPath</> data type, it shall to put private
+   fields on the supplied <literal>StringInfo</> with text form.
+   Note that common fields in <literal>CustomPath</> are handled by backend,
+   so extension needs to do nothing special.
+  </para>
+ </sect1>
+
+ <sect1 id="cpp-plan-callbacks">
+  <title>Custom Plan Callbacks</title>
+  <para>
+   This section introduces callback functions of <literal>CustomPlan</>
+   structure; defined in the <literal>CustomPlanMethods</>.
+  </para>
+  <para>
+<programlisting>
+Plan      *
+InitCustomPlan(CustomPlan *custom_plan,
+               PlannerInfo *root,
+               CustomPath *best_path,
+               List *tlist,
+               List *clauses);
+</programlisting>
+   It initializes the <literal>CustomPlan</> node being acquired by
+   <literal>CreateCustomPlan</> callback.
+   The backend takes some common initializations prior to its invocation.
+   <literal>tlist</> and <literal>clauses</> are extracted from the path
+   node according to the usual manner, so all custom plan provider has to
+   do is putting these members if nothing special are done.
+  </para>
+
+  <para>
+<programlisting>
+void
+SetCustomPlanRef(PlannerInfo *root,
+                 CustomPlan *custom_plan,
+                 int rtoffset);
+</programlisting>
+   It adjusts <literal>varno</> and <literal>varattno</> of var-nodes in
+   the expression tree chained from <literal>CustomPlan</> node (including
+   private fields in the inherited data type).
+   In case of usual relation scan, <literal>rtoffset</> shall be added to
+   <literal>varno</> of var-nodes and <literal>scanrelid</> of plan node,
+   then <literal>fix_scan_expr</> shall be called on expression nodes to
+   track plan dependency.
+  </para>
+
+  <para>
+<programlisting>
+bool
+SupportBackwardScan(CustomPlan *custom_plan);
+</programlisting>
+   It is an optional callback, which tells the backend whether this custom-
+   plan node supports backward scan or not. If <literal>NULL</>, it means
+   backward scan is not supported.
+  </para>
+
+  <para>
+<programlisting>
+void
+FinalizeCustomPlan(PlannerInfo *root,
+                   CustomPlan *custom_plan,
+                   bool (*finalize_primnode)(),
+                   void *finalize_context);
+</programlisting>
+   It is an optional callback, which applies <literal>finalize_primenode</>
+   on the expression nodes of private fields because only custom-plan provider
+   knows what private fields are expression node to be finalized.
+   Note that backend applies <literal>finalize_primenode</> on
+   the <literal>tlist</> and <literal>qual</> of the base plan node,
+   so custom-plan provider shall do nothing special, if it has no private
+   expression node.
+   Also, it handles recursive stuff on the <literal>lefttree</> and
+   <literal>righttree</>, so it does not need to handle recursive walks.
+  </para>
+
+  <para>
+<programlisting>
+Node *
+CreateCustomPlanState(CustomPlan *custom_plan);
+</programlisting>
+   It populates a <literal>CustomPlanState</> (or inherited data type)
+   node according to the supplied <literal>CustomPlan</> node preliminary
+   constructed, on the beginning of query executor.
+   Only custom plan provider can know exact size of the node to be
+   allocated, this callback allocate a <literal>CustomPlanState</> node
+   with <literal>CustomExecMethods</> callbacks table and arbitrary
+   private fields.
+  </para>
+  <para>
+   Note that main purpose of this callback is allocation of
+   <literal>CustomPlanState</> node, not initialization of individual
+   fields because it shall be handled on the <literal>BeginCustomPlan</>
+   callback to be invoked next to the common usual initialization.
+  </para>
+
+  <para>
+<programlisting>
+void
+TextOutCustomPlan(StringInfo str,
+                  const CustomPlan *node);
+</programlisting>
+   It makes a text representation of custom plan node. If custom-plan
+   provider extends <literal>CustomPlan</> data type, it shall put private
+   fields on the supplied <literal>StringInfo</> with text form.
+   Note that common fields in <literal>CustomPlan</> are handled by backend,
+   so extension needs to do nothing special.
+  </para>
+
+  <para>
+<programlisting>
+CustomPlan *
+CopyCustomPlan(const CustomPlan *from);
+</programlisting>
+   It duplicate a <literal>CustomPlan</> node onto a newly allocated one.
+   If custom-plan provider extends the <literal>CustomPlan</> node, it shall
+   copy the private fields and callback table but no need to copy the common
+   <literal>scan</> field in the <literal>CustomPlan</> data type.
+  </para>
+ </sect1>
+
+ <sect1 id="cpp-exec-callbacks">
+  <title>Custom Executor Callbacks</title>
+  <para>
+   This section introduces callback functions of <literal>CustomPlanState</>
+   structure; defined in the <literal>CustomExecMethods</>.
+  </para>
+  <para>
+<programlisting>
+void
+BeginCustomPlan(CustomPlanState *node,
+                EState *estate,
+                int eflags);
+</programlisting>
+   It begins execution of custom-plan. This callback is invoked during
+   executor startup to initialize the supplied <literal>CustomPlanState</>
+   that was constructed on the <literal>CreateCustomPlanState</> above.
+   The custom-plan provider shall have initialization of its private fields
+   and common fields within <literal>CustomPlanState</> if needed, because
+   backend code already initializes expressions on its <literal>targetlist</>
+   and <literal>qual</>, assigns result slot according to the
+   <literal>targetlist</> and also assigns scan slot if <literal>scanrelid</>
+   is valid.
+  </para>
+
+  <para>
+<programlisting>
+TupleTableSlot *
+ExecCustomPlan(CustomPlanState *node);
+</programlisting>
+   It fetches one row from the custom-plan node, returning it in a tuple
+   table slot (<literal>ps_ResultTupleSlot</> of <literal>PlanState</>
+   shall be used) or <literal>NULL</> if no more rows are available.
+   The tuple table slot infrastructure allows either a physical or virtual
+   tuple to be returned; in most cases the latter choice is preferable from
+   a performance standpoint.
+   The rows being returned have to match the tuple-descriptor of the
+   <literal>PlanState</>
+  </para>
+  <para>
+   Note that this call is under a short-lived memory context that will be
+   reset for each invocation. So, it may be a good choice to switch
+   <literal>es_query_cxt</> of the <literal>EState</>, to acquire per-scan
+   duration memory.
+  </para>
+
+  <para>
+<programlisting>
+Node *
+MultiExecCustomPlan(CustomPlanState *node);
+</programlisting>
+   It allows to return arbitrary data structure to the upper node, unlike
+   usual <literal>ExecCustomPlan</>. Built-in code has no invocation path
+   to call <literal>MultiExecProcNode</> towards <literal>CustomPlanState</>
+   node, so it is invoked only when a particular custom-plan provider made
+   a stacked custom-plan nodes and called <literal>MultiExecProcNode</> to
+   this underlying node.
+  </para>
+  <para>
+   Note that it is custom-plan provider's responsibility to translate the
+   arbitrary data structure into <productname>PostgreSQL</>'s complianced
+   data structure when top-level <literal>CustomPlanState</> returns a row
+   using <literal>ExecCustomPlan</>.
+  </para>
+
+  <para>
+<programlisting>
+void
+EndCustomPlan(CustomPlanState *node);
+</programlisting>
+   It ends the execution of custom plan and release any resources held by
+   this node. If custom-plan provider acquired resources that is not
+   released automatically at end of executor, it is responsibility of the
+   custom plan provider.
+  </para>
+
+  <para>
+<programlisting>
+void
+ReScanCustomPlan(CustomPlanState *node);
+</programlisting>
+   It restarts the scan from the beginning.  Note that any parameters
+   the scan depends on may have changed value, so the new scan does not
+   necessarily return exactly the same rows.
+  </para>
+
+  <para>
+<programlisting>
+void *
+MarkPosCustomPlan(CustomPlanState *node);
+</programlisting>
+   It is an optional callback, if <literal>CustomPlanState</> was populated
+   from the <literal>CustomPlanMarkPos</>. Elsewhere, it shall not be called
+   and <literal>NULL</> is suitable.
+   It saves current scan position on somewhere in private fields of
+   <literal>CustomPlanState</>, to restore the position later.
+  </para>
+
+  <para>
+<programlisting>
+void *
+RestrPosCustomPlan(CustomPlanState *node);
+</programlisting>
+   It is an optional callback, if <literal>CustomPlanState</> was populated
+   from the <literal>CustomPlanMarkPos</>. Elsewhere, it shall not be called
+   and <literal>NULL</> is suitable.
+   It restores the previous scan position saved by
+   the <literal>MarkPosCustomPlan</> above.
+  </para>
+
+  <para>
+<programlisting>
+void
+ExplainCustomPlanTargetRel(CustomPlanState *node,
+                           ExplainState *es);
+</programlisting>
+   It is an optional callback, to show the target relation to be scanned.
+   In most cases, custom plan provider put text representation of the relation
+   to be scanned according to the manner in <literal>ExplainTargetRel</>.
+  </para>
+
+  <para>
+<programlisting>
+void
+ExplainCustomPlan(CustomPlanState *node,
+                  List *ancestors,
+                  ExplainState *es);
+</programlisting>
+   It is an optional callback, to show custom-plan specific explain output.
+  </para>
+
+  <para>
+<programlisting>
+void
+ExplainCustomPreScanNode(CustomPlanState *node,
+                         Bitmapset **rels_used);
+</programlisting>
+   It is an optional callback, to inform the backend which relation is
+   referenced. It shall set <literal>scanrelid</> of the target relation.
+   If <literal>NULL</>, it means this custom-plan provider never
+   references base relations.
+  </para>
+
+  <para>
+<programlisting>
+Node   *
+GetSpecialCustomVar(CustomPlanState *node,
+                    Var *varnode,
+                    PlanState **child_ps);
+</programlisting>
+   It is an optional callback, to solve references to special varno on
+   the <literal>CustomPlanState</> when <literal>EXPLAIN</> needs the
+   text form of the column actually referenced.
+   In case when custom-plan provider adjusted <literal>varno</> of varnodes
+   on the expression tree to use special varnos (<literal>INNER_VAR</>,
+   <literal>OUTER_VAR</> or <literal>INDEX_VAR</>), custom-plan provider has
+   to inform the backend which column is mapped on the underlying plan-state.
+  </para>
+  <para>
+   This callback is expected to return <literal>Var</> node to reference
+   an actual variable on the underlying <literal>PlanState</> that shall be
+   set on the <literal>child_ps</> argument.
+  </para>
+ </sect1>
+</chapter>
+
diff --git a/doc/src/sgml/filelist.sgml b/doc/src/sgml/filelist.sgml
index 5902f97..a9b9efc 100644
--- a/doc/src/sgml/filelist.sgml
+++ b/doc/src/sgml/filelist.sgml
@@ -92,6 +92,7 @@
 <!ENTITY nls        SYSTEM "nls.sgml">
 <!ENTITY plhandler  SYSTEM "plhandler.sgml">
 <!ENTITY fdwhandler SYSTEM "fdwhandler.sgml">
+<!ENTITY custom-plan-provider SYSTEM "custom-plan-provider.sgml">
 <!ENTITY logicaldecoding SYSTEM "logicaldecoding.sgml">
 <!ENTITY protocol   SYSTEM "protocol.sgml">
 <!ENTITY sources    SYSTEM "sources.sgml">
diff --git a/doc/src/sgml/postgres.sgml b/doc/src/sgml/postgres.sgml
index 9bde108..4702178 100644
--- a/doc/src/sgml/postgres.sgml
+++ b/doc/src/sgml/postgres.sgml
@@ -242,6 +242,7 @@
   &nls;
   &plhandler;
   &fdwhandler;
+  &custom-plan-provider;
   &geqo;
   &indexam;
   &gist;
diff --git a/doc/src/sgml/ref/allfiles.sgml b/doc/src/sgml/ref/allfiles.sgml
index b685e16..ab35742 100644
--- a/doc/src/sgml/ref/allfiles.sgml
+++ b/doc/src/sgml/ref/allfiles.sgml
@@ -55,6 +55,7 @@ Complete list of usable sgml source files in this directory.
 <!ENTITY createCast         SYSTEM "create_cast.sgml">
 <!ENTITY createCollation    SYSTEM "create_collation.sgml">
 <!ENTITY createConversion   SYSTEM "create_conversion.sgml">
+<!ENTITY createCustomPlanProvider SYSTEM "create_custom_plan_provider.sgml">
 <!ENTITY createDatabase     SYSTEM "create_database.sgml">
 <!ENTITY createDomain       SYSTEM "create_domain.sgml">
 <!ENTITY createEventTrigger SYSTEM "create_event_trigger.sgml">
@@ -95,6 +96,7 @@ Complete list of usable sgml source files in this directory.
 <!ENTITY dropCast           SYSTEM "drop_cast.sgml">
 <!ENTITY dropCollation      SYSTEM "drop_collation.sgml">
 <!ENTITY dropConversion     SYSTEM "drop_conversion.sgml">
+<!ENTITY dropCustomPlanProvider SYSTEM "drop_custom_plan_provider.sgml">
 <!ENTITY dropDatabase       SYSTEM "drop_database.sgml">
 <!ENTITY dropDomain         SYSTEM "drop_domain.sgml">
 <!ENTITY dropEventTrigger   SYSTEM "drop_event_trigger.sgml">
diff --git a/doc/src/sgml/ref/create_custom_plan_provider.sgml b/doc/src/sgml/ref/create_custom_plan_provider.sgml
new file mode 100644
index 0000000..0816584
--- /dev/null
+++ b/doc/src/sgml/ref/create_custom_plan_provider.sgml
@@ -0,0 +1,139 @@
+<!--
+doc/src/sgml/ref/create_custom_plan_provider.sgml
+PostgreSQL documentation
+-->
+
+<refentry id="SQL-CREATECUSTOMPLANPROVIDER">
+ <indexterm zone="sql-createcustomplanprovider">
+  <primary>CREATE CUSTOM PLAN PROVIDER</primary>
+ </indexterm>
+
+ <refmeta>
+  <refentrytitle>CREATE CUSTOM PLAN PROVIDER</refentrytitle>
+  <manvolnum>7</manvolnum>
+  <refmiscinfo>SQL - Language Statements</refmiscinfo>
+ </refmeta>
+
+ <refnamediv>
+  <refname>CREATE CUSTOM PLAN PROVIDER</refname>
+  <refpurpose>define a new custom plan provider</refpurpose>
+ </refnamediv>
+
+ <refsynopsisdiv>
+<synopsis>
+CREATE CUSTOM PLAN PROVIDER <replaceable class="parameter">cpp_name</replaceable> FOR <replaceable class="parameter">cpp_class</replaceable>
+    HANDLER <replaceable class="parameter">handler_function</replaceable>
+</synopsis>
+ </refsynopsisdiv>
+
+ <refsect1>
+  <title>Description</title>
+
+  <para>
+   <command>CREATE CUSTOM PLAN PROVIDER</command> defines a new custom-plan
+   provider.
+   The user who defines the custom-plan provider has to be a superuser.
+  </para>
+
+  <para>
+   A custom-plan provider can offer the query planner alternative options
+   to scan relation, or potentially join relations and so on, in addition
+   to the built-in logics. It is usually extension modules that implement
+   callbacks according to the custom-plan interface.
+  </para>
+  <para>
+   This statement defines a couple of an entrypoint of custom-plan provider
+   and its supporting workload type. Right now, <literal>scan</literal> is
+   the only class being supported; that enables to call extension's
+   callback during query execution instead of built-in routines like
+   <literal>SeqScan</literal> or <literal>IndexScan</literal> if its
+   cost estimation is enough reasonable.
+  </para>
+ </refsect1>
+
+ <refsect1>
+  <title>Parameters</title>
+
+  <variablelist>
+   <varlistentry>
+    <term><replaceable class="parameter">cpp_name</replaceable></term>
+    <listitem>
+     <para>
+      The name of the custom-plan provider to be created.
+     </para>
+    </listitem>
+   </varlistentry>
+
+   <varlistentry>
+    <term><replaceable class="parameter">cpp_class</replaceable></term>
+    <listitem>
+     <para>
+      Workload type on which custom-plan provider can perform.
+      Only <literal>SCAN</literal> is supported option right now.
+     </para>
+    </listitem>
+   </varlistentry>
+
+   <varlistentry>
+    <term><replaceable class="parameter">handler_function</replaceable></term>
+    <listitem>
+     <para>
+      A function to be called when query planner is finding the best path
+      to scan a relation.
+     </para>
+    </listitem>
+   </varlistentry>
+  </variablelist>
+ </refsect1>
+
+ <refsect1>
+  <title>Notes</title>
+
+  <para>
+   The function that performs as a custom-plan provider shall be declared
+   to return <literal>void</> and take one argument with <literal>internal</>
+   data type.
+   The core <productname>PostgreSQL</> calls custom-plan provider function
+   with a set of information about planner's state and relation(s) to be
+   scanned, then this function shall check whether it can offer alternative
+   scan paths or not.
+   If available, it constructs a path object derived from
+   <literal>CustomPath</> structure, that contains a set of callbacks
+   including the ones to populate <literal>CustomPlan</> or
+   <literal>CustomPlanState</> object later.
+   If extension needs to save its private information in these object,
+   define a new structure that extends above data types.
+  </para>
+ </refsect1>
+
+ <refsect1>
+  <title>Examples</title>
+  <para>
+   Create a custom-plan provider <literal>ctidscan</> that uses the funcion
+   <literal>ctidscanaddpath</>.   
+<programlisting>
+CREATE CUSTOM PLAN PROVIDER ctidscan FOR scan HANDLER ctidscanaddpath;
+</programlisting>
+  </para>
+ </refsect1>
+
+ <refsect1>
+  <title>Compatibility</title>
+  <para>
+   There is no <command>CREATE CUSTOM PLAN</command> command
+   in the SQL standard.
+  </para>
+ </refsect1>
+
+ <refsect1>
+  <title>See Also</title>
+
+  <simplelist type="inline">
+   <member><xref linkend="sql-dropcustomplanprovider"></member>
+  </simplelist>
+  <simplelist type="inline">
+   <member><xref linkend="custom-plan"></member>
+  </simplelist>
+ </refsect1>
+
+</refentry>
diff --git a/doc/src/sgml/ref/drop_custom_plan_provider.sgml b/doc/src/sgml/ref/drop_custom_plan_provider.sgml
new file mode 100644
index 0000000..6a305a8
--- /dev/null
+++ b/doc/src/sgml/ref/drop_custom_plan_provider.sgml
@@ -0,0 +1,108 @@
+<!--
+doc/src/sgml/ref/drop_custom_plan_provider.sgml
+PostgreSQL documentation
+-->
+
+<refentry id="SQL-DROPCUSTOMPLANPROVIDER">
+ <indexterm zone="sql-dropcustomplanprovider">
+  <primary>DROP CUSTOM PLAN PROVIDER</primary>
+ </indexterm>
+
+ <refmeta>
+  <refentrytitle>DROP CUSTOM PLAN PROVIDER</refentrytitle>
+  <manvolnum>7</manvolnum>
+  <refmiscinfo>SQL - Language Statements</refmiscinfo>
+ </refmeta>
+
+ <refnamediv>
+  <refname>DROP CUSTOM PLAN PROVIDER</refname>
+  <refpurpose>remove a custom-plan provider</refpurpose>
+ </refnamediv>
+
+ <refsynopsisdiv>
+<synopsis>
+DROP CUSTOM PLAN PROVIDER [ IF EXISTS ] <replaceable class="parameter">cpp_name</replaceable> [ CASCADE | RESTRICT ]
+</synopsis>
+ </refsynopsisdiv>
+
+ <refsect1>
+  <title>Description</title>
+
+  <para>
+   <command>DROP CUSTOM PLAN PROVIDER</command> removes an existing custom
+   plan provider. To execute this command, the current user must be superuser.
+  </para>
+ </refsect1>
+
+ <refsect1>
+  <title>Parameters</title>
+
+  <variablelist>
+   <varlistentry>
+    <term><literal>IF EXISTS</literal></term>
+    <listitem>
+     <para>
+      Do not throw an error if the custom-plan provider does not exist.
+      A notice is issued in this case.
+     </para>
+    </listitem>
+   </varlistentry>
+
+   <varlistentry>
+    <term><replaceable class="parameter">name</replaceable></term>
+    <listitem>
+     <para>
+      The name of an existing custom-plan provider.
+     </para>
+    </listitem>
+   </varlistentry>
+
+   <varlistentry>
+    <term><literal>CASCADE</literal></term>
+    <listitem>
+     <para>
+      Automatically drop objects that depend on the custom-plan provider.
+     </para>
+    </listitem>
+   </varlistentry>
+
+   <varlistentry>
+    <term><literal>RESTRICT</literal></term>
+    <listitem>
+     <para>
+      Refuse to drop the custom-plan provider if any objects depend on it.
+      This is the default.
+     </para>
+    </listitem>
+   </varlistentry>
+  </variablelist>
+ </refsect1>
+
+ <refsect1>
+  <title>Examples</title>
+
+  <para>
+   Drop a custom-plan provider <literal>foo</> if it exists:
+<programlisting>
+DROP CUSTOM PLAN PROVIDER IF EXISTS foo;
+</programlisting></para>
+ </refsect1>
+
+ <refsect1>
+  <title>Compatibility</title>
+
+  <para>
+   There is no <command>DROP CUSTOM PLAN</command> command
+   in the SQL standard.
+  </para>
+ </refsect1>
+
+ <refsect1>
+  <title>See Also</title>
+
+  <simplelist type="inline">
+   <member><xref linkend="sql-createcustomplanprovider"></member>
+  </simplelist>
+ </refsect1>
+
+</refentry>
diff --git a/doc/src/sgml/reference.sgml b/doc/src/sgml/reference.sgml
index 6ec1263..1a3dbdd 100644
--- a/doc/src/sgml/reference.sgml
+++ b/doc/src/sgml/reference.sgml
@@ -83,6 +83,7 @@
    &createCast;
    &createCollation;
    &createConversion;
+   &createCustomPlanProvider;
    &createDatabase;
    &createDomain;
    &createEventTrigger;
@@ -123,6 +124,7 @@
    &dropCast;
    &dropCollation;
    &dropConversion;
+   &dropCustomPlanProvider;
    &dropDatabase;
    &dropDomain;
    &dropEventTrigger;
diff --git a/src/backend/catalog/Makefile b/src/backend/catalog/Makefile
index a974bd5..f7e29eb 100644
--- a/src/backend/catalog/Makefile
+++ b/src/backend/catalog/Makefile
@@ -39,7 +39,7 @@ POSTGRES_BKI_SRCS = $(addprefix $(top_srcdir)/src/include/catalog/,\
 	pg_ts_config.h pg_ts_config_map.h pg_ts_dict.h \
 	pg_ts_parser.h pg_ts_template.h pg_extension.h \
 	pg_foreign_data_wrapper.h pg_foreign_server.h pg_user_mapping.h \
-	pg_foreign_table.h \
+	pg_foreign_table.h pg_custom_plan_provider.h \
 	pg_default_acl.h pg_seclabel.h pg_shseclabel.h pg_collation.h pg_range.h \
 	toasting.h indexing.h \
     )
diff --git a/src/backend/catalog/dependency.c b/src/backend/catalog/dependency.c
index d41ba49..496bc9a 100644
--- a/src/backend/catalog/dependency.c
+++ b/src/backend/catalog/dependency.c
@@ -30,6 +30,7 @@
 #include "catalog/pg_constraint.h"
 #include "catalog/pg_conversion.h"
 #include "catalog/pg_conversion_fn.h"
+#include "catalog/pg_custom_plan_provider.h"
 #include "catalog/pg_database.h"
 #include "catalog/pg_default_acl.h"
 #include "catalog/pg_depend.h"
@@ -154,7 +155,8 @@ static const Oid object_classes[MAX_OCLASS] = {
 	UserMappingRelationId,		/* OCLASS_USER_MAPPING */
 	DefaultAclRelationId,		/* OCLASS_DEFACL */
 	ExtensionRelationId,		/* OCLASS_EXTENSION */
-	EventTriggerRelationId		/* OCLASS_EVENT_TRIGGER */
+	EventTriggerRelationId,		/* OCLASS_EVENT_TRIGGER */
+	CustomPlanProviderRelationId,		/* OCLASS_CPP */
 };
 
 
@@ -1249,6 +1251,10 @@ doDeletion(const ObjectAddress *object, int flags)
 			RemoveEventTriggerById(object->objectId);
 			break;
 
+		case OCLASS_CPP:
+			RemoveCustomPlanProviderById(object->objectId);
+			break;
+
 		default:
 			elog(ERROR, "unrecognized object class: %u",
 				 object->classId);
@@ -2316,6 +2322,9 @@ getObjectClass(const ObjectAddress *object)
 
 		case EventTriggerRelationId:
 			return OCLASS_EVENT_TRIGGER;
+
+		case CustomPlanProviderRelationId:
+			return OCLASS_CPP;
 	}
 
 	/* shouldn't get here */
